import Base: binomial

"""
    binomial(p, k::Integer)
 
where `p` is a `SimplePolynomial` or a `SimpleRationalFunction` returns the 
binomial coefficient.

# Example
```
julia> x = getx()
x

julia> binomial(x,3)
1//3*x - 1//2*x^2 + 1//6*x^3

julia> p = binomial(x,3)
1//3*x - 1//2*x^2 + 1//6*x^3

julia> p(10)
120//1

julia> binomial(10,3)
120
```
"""
function binomial(
    p::T,
    k::Integer,
) where {T<:Union{SimplePolynomial,SimpleRationalFunction}}
    if k < 0
        return zero(T)
    end

    if k == 0
        return one(T)
    end

    return prod(p - j for j = 0:k-1) // factorial(k)

end

# How to print SimplePolynomials? We take advantage of the
# excellent printing available in the Polynomials module!

import Base: string, show
export integerize

# The all_ones_denom function checks if all the coefficients
# are (Gaussian) integers, but perhaps of Rational type.

function all_ones_denom(list::Vector{T})::Bool where {T<:IntegerX}
    return true
end
#
# function all_ones_denom(list::Vector{Complex{T}})::Bool where T <: Integer
#     return true
# end

function all_ones_denom(list::Vector{T})::Bool where {T<:Real}
    return all(denominator.(list) .== 1)
end

function all_ones_denom(list::Vector{T})::Bool where {T<:Complex}
    return all_ones_denom(real.(list)) && all_ones_denom(imag.(list))
end

function all_ones_denom(p::SimplePolynomial)::Bool
    return all_ones_denom(p.data)
end

function _top(x::T) where {T<:Union{Rational,Integer}}
    return numerator(x)
end

function _top(x::T) where {T<:Complex}
    return numerator(real(x)) + numerator(imag(x)) * im
end

_top(x::AbstractMod) = x

"""
`integerize(p::SimplePolynomial)` is useful when `p`
has `Rational` coefficients all of whose denominators are `1`.
In that case, `integerize(p)` returns a polynomial equal to the
original, but with coefficients that are integers (or Gaussian integers).
However, if any denominators are not `1`, the original polynomial
is returned.
"""
function integerize(p::SimplePolynomial)
    if all_ones_denom(p)
        return SimplePolynomial(_top.(p.data))
    end
    return p
end

"""
`string(p::SimplePolynomial)` returns a nice `String` representation
of `p`.
"""
function string(p::SimplePolynomial)
    return string(Polynomial(integerize(p)))
end


function show(io::IO, p::SimplePolynomial)
    print(io, string(p))
end






export string3


function pstring(p::SimplePolynomial)
    nterms = count((x) -> (x != 0), p.data)
    if nterms <= 1
        return string(p)
    end
    return "(" * string(p) * ")"
end


function string(f::SimpleRationalFunction)
    return pstring(f.num) * " / " * pstring(f.den)
end





function show(io::IO, f::SimpleRationalFunction)
    print(io, string(f))
end


function string3(f::SimpleRationalFunction)
    top = string(numerator(f))
    bot = string(denominator(f))

    n1 = length(top)
    n2 = length(bot)
    n = max(n1, n2)

    pad1 = 0
    pad2 = 0

    if n1 < n
        pad1 = div(n - n1, 2)
    else
        pad2 = div(n - n2, 2)
    end

    line1 = " "^pad1 * top
    line2 = "-"^n
    line3 = " "^pad2 * bot
    NL = "\n"

    return line1 * NL * line2 * NL * line3
end

export newton_solve, newton_roots

function newton_function(p::SimplePolynomial)::SimpleRationalFunction
    x = getx()
    d = gcd(p, p')
    pp = numerator(p / d)
    return x - pp / pp'
end


"""
`newton_solve(p::SimplePolynomial, x0::Number, nits::Integer)`
finds a root of the polynomial `p` by running `nits` iterations 
of Newton's method starting at `x0`.
"""
function newton_solve(p::SimplePolynomial, x0::Number, nits::Integer = 10)::Number
    newt_func = newton_function(p)
    for k = 1:nits
        x0 = newt_func(x0)
    end
    return x0
end

"""
`newton_roots(p::SimplePolynomial, nits::Integer=10)`
uses Newton's method to find all the roots of the polynomial `p`.
This function uses `roots` to provide a starting value for each root 
and then applies Newton's method to achieve much high accuracy.
"""
function newton_roots(p, nits::Integer = 10)
    rlist = roots(p)
    return [newton_solve(p, x, nits) for x in rlist]
end

module SimplePolynomials
using Mods, Primes, Multisets

import Base: getindex, (==), show, zero, one, eltype, adjoint
import Base: numerator, denominator, big, inv

import Polynomials: degree, Polynomial, coeffs, roots, derivative

export SimplePolynomial, degree, coeffs, getx, Polynomial, roots
export derivative, integral, lead, make_function

# IntegerX is any sort of real or Gaussian integer
IntegerX = Union{S,Complex{S},AbstractMod} where {S<:Integer}

# RationalX is a Rational or Complex Rational based on integers
RationalX = Union{Rational{S},Complex{Rational{S}}} where {S<:Integer}

# CoefX is the type we allow for coefficients ... all exact
CoefX = Union{IntegerX,RationalX}


_enlarge(x::Integer) = big(x)
_enlarge(x::Rational) = big(x)
_enlarge(x::Complex) = big(x)
_enlarge(x::AbstractMod) = x

abstract type AbstractAlgebraicFunction end
export AbstractAlgebraicFunction

struct SimplePolynomial <: AbstractAlgebraicFunction
    data::Vector
    func::Function
    function SimplePolynomial(list::Vector{T}) where {T<:CoefX}
        list = _enlarge.(_chomp(list))
        f = x -> @evalpoly(x, list...)
        new(_chomp(list), f)
    end
end

function SimplePolynomial(c...)
    n = length(c)
    T = typeof(sum(c))
    data = zeros(T, n)
    for j = 1:n
        data[j] = c[j]
    end
    SimplePolynomial(data)
end


"""
`make_function(p::SimplePolynomial)` or
`make_function(f::SimpleRationalFunction)`
returns a Julia `Function` that evaluates `p` or `f`.
Of course one can use `p(x)` or `f(x)`, but the function returned
can then be passed to (for example) `plot`.

Please note that `p(x)` [or `f(x)`] is already quite efficient.
"""
make_function(p::SimplePolynomial) = p.func



SimplePolynomial() = SimplePolynomial([0])
SimplePolynomial(p::SimplePolynomial) = SimplePolynomial(p.data)

# equality checking

(==)(p::SimplePolynomial, q::SimplePolynomial) = p.data == q.data
(==)(p::SimplePolynomial, a::T) where {T<:CoefX} = p == SimplePolynomial(a)
(==)(a::T, p::SimplePolynomial) where {T<:CoefX} = p == SimplePolynomial(a)


coeffs(p::SimplePolynomial) = copy(p.data)
eltype(p::SimplePolynomial) = eltype(p.data)

"""
`lead(p::SimplePolynomial)` returns the coefficient of the highest
power of `x` in the polynomial `p`. This is nonzero unless `p` is
the zero polynomial.
"""
lead(p::SimplePolynomial) = p.data[end]


# conversion to/from Polynomial type
SimplePolynomial(P::Polynomial) = SimplePolynomial(P.coeffs)
Polynomial(p::SimplePolynomial) = Polynomial(small.(p.data))


"""
`_chomp(list)` creates a new list by removing all trailing zeros
unless that would remove everything, in which case we leave a single zero.
"""
function _chomp(list::Vector{T})::Vector{T} where {T<:Number}
    if length(list) == 0 || all(list .== 0)
        return T[0]
    end
    k = findlast(list .!= 0)
    return list[1:k]
end


"""
`_chomp!(list)` modifies list by removing all trailing zeros, unless
the list is entirely zeros in which case we leave a single 0.
"""
function _chomp!(list::Vector{T}) where {T<:Number}
    while length(list) > 1
        n = length(list)
        if list[n] != 0
            return
        end
        deleteat!(list, n)
    end
end

"""
`degree(p::SimplePolynomial)` returns the degree of `p`; that is,
the highest exponent with a nonzero coefficient. If `p`
is the zero polynomial, then `-1` is returned.
"""
function degree(p::SimplePolynomial)
    n = length(p.data)
    if n > 1 || p.data[1] != 0
        return n - 1
    end
    return -1
end

"""
For a `SimplePolynomial`, `p`, use `p[k]` to read the coefficient
of `x^k`. In particular, `p[0]` is the constant term. If `k` is
larger than the degree of the polynomial, `0` is returned.
"""
function getindex(p::SimplePolynomial, k::Int)
    n = length(p.data)
    if k < 0
        error("index [$k] must be nonnegative")
    end

    if k >= n
        return 0
    end

    return p.data[k+1]
end

# This implements evaluation
function (p::SimplePolynomial)(x)
    try
        return p.func(x)
    catch
    end
    result = 0
    n = degree(p)
    for j = n:-1:0
        result *= x
        result += p[j]
    end
    return result
end


# special case when arg is a matrix
function (p::SimplePolynomial)(x::AbstractMatrix{T}) where {T}
    r, c = size(x)
    if r != c
        error("number of rows $r must equal the number of columns $c")
    end
    S = eltype(p)
    ST = promote_type(S, T)
    id = zeros(ST, r, r)
    for i = 1:r
        id[i, i] = 1
    end
    result = zeros(ST, r, r)
    n = degree(p)
    for j = n:-1:0
        result *= x
        result += p[j] * id
    end
    return result
end


"""
`getx()` is a convenient way to create `SimplePolynomial(0,1)`.
Typical use:
```
x = getx()
p = 2 + x - 3*x^2
```
Use `getx(T)` for coefficients of type `T`, e.g., `getx(Mod{13})`.
"""
function getx(T = Int)
    return SimplePolynomial(T(0), T(1))
end


zero(::Type{SimplePolynomial}) = SimplePolynomial(zero(Int))
one(::Type{SimplePolynomial}) = SimplePolynomial(one(Int))

zero(::SimplePolynomial) = SimplePolynomial(zero(Int))
one(::SimplePolynomial) = SimplePolynomial(one(Int))

zero(::Type{AbstractAlgebraicFunction}) = SimplePolynomial(zero(Int))
one(::Type{AbstractAlgebraicFunction}) = SimplePolynomial(one(Int))

zero(::AbstractAlgebraicFunction) = SimplePolynomial(zero(Int))
one(::AbstractAlgebraicFunction) = SimplePolynomial(one(Int))

roots(p::SimplePolynomial) = roots(Polynomial(p))

"""
`derivative(P::SimplePolynomial)` returns the derivative of `P`.
May also be found as `P'`.
"""
function derivative(P::SimplePolynomial)
    if degree(P) < 1
        return SimplePolynomial(0)
    end
    data = [k * P[k] for k = 1:degree(P)]
    return SimplePolynomial(data)
end
adjoint(P::SimplePolynomial) = derivative(P)


"""
`integral(P::SimplePolynomial)` returns the integral of `P`
with constant term equal to zero.
"""
function integral(P::SimplePolynomial)
    if P == 0
        return P
    end
    data = [P[k-1] // k for k = 1:degree(P)+1]
    prepend!(data, 0)
    return SimplePolynomial(data)
end


include("SimpleRationalFunctions.jl")
include("show.jl")
include("arithmetic.jl")
include("rat_arith.jl")
include("gcd.jl")
include("small.jl")
include("rational_roots.jl")
include("newton.jl")
include("bin_extend.jl")
include("interpolate.jl")
end

export rational_roots

"""
`_divisors(n)` returns a `Set` of all the positive divisors of the integer `n`.
"""
function _divisors(n::Integer)
    @assert n != 0 "Can't list all the divisors of zero"
    if abs(n) == 1
        return Set(1)
    end
    f = collect(factor(abs(n)))
    powers = tuple([x[2] for x in f]...)
    plist = [x[1] for x in f]
    np = length(plist)
    master_idx = tuple([0:t for t in powers]...)

    return Set(
        prod(plist[k]^idx[k] for k = 1:np) for idx in Iterators.product(master_idx...)
    )
end

"""
`rational_roots(p::SimplePolynomial)` returns a `Multiset` of all rational roots 
of `p`.
"""
function rational_roots(p::SimplePolynomial)::Multiset
    @assert degree(p) >= 0 "Polynomial must not be identically zero"
    T = eltype(p)
    if T <: Complex || T <: AbstractMod
        error("Coefficients are not (real) rational numbers; they are $T")
    end
    if T <: Rational
        dlist = denominator.(coeffs(p))
        p *= lcm(dlist)
        p = integerize(p)
    end
    # p = big(p)
    R = Multiset{Rational{BigInt}}()   # this holds all the answers

    while p[0] == 0
        push!(R, 0)
        clist = coeffs(p)
        p = SimplePolynomial(clist[2:end])
    end

    a = lead(p)   # leading coefficient
    b = p[0]      # constant term

    A = _divisors(a)
    B1 = _divisors(b)
    B2 = Set(-t for t in B1)
    B = collect(union(B1, B2))   # all possible rational roots are in the list B

    x = getx()

    for a in A
        for b in B
            r = b // a
            while p(r) == 0
                push!(R, r)   # add b to the output multiset 
                p = numerator(p // (x - r))
            end
        end
    end

    return R

end

import Base: gcd, lcm


function gcd(a::SimplePolynomial, b::SimplePolynomial)
    #try
    d = integerize(_gcd(a, b))
    return d
    # catch
    #     aa = big(a)
    #     bb = big(b)
    #     dd = _gcd(aa,bb)
    #     d = integerize(dd)
    #     return d
    # end
end

function _gcd(a::SimplePolynomial, b::SimplePolynomial)

    if a == 0 && b == 0
        error("The two arguments cannot both be zero")
    end

    if a == 0
        return b
    end

    if b == 0
        return a
    end

    q, r = divrem(a, b)
    return monic(_gcd(b, monic(r)))
end


function lcm(a::SimplePolynomial, b::SimplePolynomial)
    q, r = divrem(a * b, gcd(a, b))
    return monic(q)
end

export interpolate


"""
    interpolate(vals::Vector{T})::SimplePolynomial where {T<:Number}

Given a list of numbers `vals`, find a polynomial `p` that generates that list.
That is, `p(0)` gives the first value on the list, `p(1)` the second value, 
and so forth. 
"""
function interpolate(
    vals::Vector{T},
    warnings::Bool = false,
)::SimplePolynomial where {T<:Number}

    if length(vals) < 1
        error("List of values must not be empty")
    end

    list_of_lists = Vector{Vector{T}}()
    push!(list_of_lists, vals)
    z = last(list_of_lists)

    while !(all(z .== 0)) && length(z) >= 1
        if length(z) == 1 && first(z) != 0
            warnings &&
                @warn "Iterated differences did not reach zero; provide more values?"
            break
        end
        z = diff(z)
        push!(list_of_lists, z)
    end

    leads = first.(list_of_lists)

    x = getx()
    n = length(leads)
    return sum(leads[k] * binomial(x, k - 1) for k = 1:n)

end

import Base: (+), (-), (*), (/), (//), (^), divrem

export monic


# Addition

function (+)(p::SimplePolynomial, q::SimplePolynomial)
    n = max(degree(p), degree(q))
    T = typeof(p(1) + q(1))
    c = zeros(T, n + 1)
    for j = 0:n
        c[j+1] = p[j] + q[j]
    end
    return SimplePolynomial(c)
end

# polynomial + number
function (+)(p::SimplePolynomial, a::T) where {T<:CoefX}
    return p + SimplePolynomial(a)
end

function (+)(a::T, p::SimplePolynomial) where {T<:CoefX}
    return p + SimplePolynomial(a)
end

# Subtraction

function (-)(p::SimplePolynomial)
    coefs = [-x for x in p.data]
    return SimplePolynomial(coefs)
end

(-)(p::SimplePolynomial, q::SimplePolynomial) = p + (-q)
(-)(p::SimplePolynomial, a::T) where {T<:CoefX} = p + (-a)
(-)(a::T, p::SimplePolynomial) where {T<:CoefX} = a + (-p)


# Multiplication

function (*)(a::T, p::SimplePolynomial) where {T<:CoefX}
    coefs = [a * x for x in p.data]
    return SimplePolynomial(coefs)
end

(*)(p::SimplePolynomial, a::T) where {T<:CoefX} = a * p

function (*)(p::SimplePolynomial, q::SimplePolynomial)
    n = degree(p) + degree(q)

    if p == 0 || q == 0
        return SimplePolynomial(0)
    end

    coefs = [p[0] * q[0] for i = 0:n]

    for k = 1:n
        coefs[k+1] = 0 * coefs[k+1]  # clear it out
        for j = 0:k
            coefs[k+1] += p[j] * q[k-j]
        end
    end
    return SimplePolynomial(coefs)
end


# Integer exponentiation

function (^)(p::SimplePolynomial, k::S) where {S<:Integer}

    if k < 0
        f = inv(p)
        return f^(-k)
    end

    if k == 0
        return SimplePolynomial(Int(1))
    end

    if k == 1
        return p
    end

    if k == 2
        return p * p
    end

    if k % 2 == 0  # even exponent
        j = k ÷ 2
        q = p^j
        return q * q
    end

    j = k ÷ 2
    q = p^j
    return q * q * p
end


# Division

function (/)(p::SimplePolynomial, a::T) where {T<:CoefX}
    coefs = p.data .// a
    return SimplePolynomial(coefs)
end
(//)(p::SimplePolynomial, a::T) where {T<:CoefX} = p / a

"""
`monic(p::SimplePolynomial)` returns a new polynomial formed by
dividing all coefficients by the leading coefficient, thereby
yielding a monic polynomial. If `p` is zero, a zero polynomial
is returned.
"""
function monic(p::SimplePolynomial)::SimplePolynomial
    if p == 0
        return p
    end
    return p / lead(p)
end


function divrem(a::SimplePolynomial, b::SimplePolynomial)
    if b == 0
        DivideError()
    end

    #ST = typeof((a[0]+b[0])//1)
    ST = Int
    if eltype(a) <: AbstractMod || eltype(b) <: AbstractMod
        ST = eltype(a)
    else
        ST = typeof((lead(a) + lead(b)) // 1)
    end


    da = degree(a)
    db = degree(b)

    if da < db
        return SimplePolynomial(), a
    end

    leader = a.data[end] // b.data[end]

    coefs = zeros(ST, da - db + 1)
    coefs[end] = leader


    q = SimplePolynomial(coefs)
    aa = a - b * q
    qq, r = divrem(aa, b)

    return q + qq, r
end

using Test, SimplePolynomials, Polynomials, Mods, Multisets

a = SimplePolynomial(1, 1, 1)
b = SimplePolynomial(1, 2, 3)
c = SimplePolynomial(0, 1, -3, 4, 1)
x = getx()
p = (1 + x + x^3 - x^2)
q = (1 + 3x) * (1 - x) + 5

@testset "Polynomial Constructors" begin
    @test p == SimplePolynomial(1, 1, -1, 1)
    @test p == SimplePolynomial([1, 1, -1, 1])
    @test c == SimplePolynomial(c)
    @test c == SimplePolynomial(c.data)
    @test x + Mod{13}(2) == SimplePolynomial([Mod{13}(2), Mod{13}(1)])
end

@testset "Rational Function Constructors" begin
    f = p / q
    @test SimpleRationalFunction(p, q) == f
    @test f(1) == p(1) // q(1)
    f = inv(p)
    @test f(1) * p(1) == 1
end

@testset "String" begin
    p = getx() + 1
    @test string(p) == "1 + x"
end


@testset "Polynomial Arithmetic" begin
    @test a + a == 2a
    @test (a + a + a) / 3 == a
    @test a - a == 0
    @test a * a == SimplePolynomial(1, 2, 3, 2, 1)
    @test a * a * a == a^3
    @test eltype(b) == BigInt
end

@testset "Rational Function Arithmetic" begin
    f = p / q
    g = a / b
    @test f * g == (p * a) / (b * q)
    @test f + g == (p * b + a * q) // (b * q)
    @test f - g == (-g) + f
    @test f / g == (p * b) / (a * q)
    @test inv(f) == q / p
end

@testset "Complex numbers" begin
    z = a + im
    @test z(-5) == a(-5) + im
    f = (im + x) / (2 * im * x)
    @test 2f(1) == 1 - im
    z = (x - im) * (x + im)
    @test z == x^2 + 1
end

@testset "Mod numbers" begin
    z = SimplePolynomial(Mod{13}.([1, 2, 3]))
    @test z(1) == Mod{13}(6)
    f = inv(z)
    @test f(1) == inv(Mod{13}(6))
end

@testset "Polynomial GCD" begin
    p = (x - 1)^2 * (x - 2)
    q = (x - 1) * (x - 3)
    @test gcd(p, q) == x - 1

    p = (x - 1)^3 * (x - 3)
    @test gcd(p, p') == (x - 1)^2

    c = Mod{13}.(coeffs(p))
    p = SimplePolynomial(c)
    @test gcd(p, p') == (x - 1)^2
end

# @testset "Size change" begin
#     # B = big(b)
#     @test B == b
#     @test eltype(B) == BigInt
#     @test eltype(small(B)) == Int

#     r = a/b
#     @test eltype(numerator(r)) == Rational{BigInt}
#     # r = big(r)
#     # @test eltype(denominator(r)) == Rational{BigInt}
# end

@testset "PolyCalculus" begin
    p = 3x // 2 - 5x^2 + (2 - im) * x^3
    @test derivative(integral(p)) == p
end

@testset "Mod Polys" begin
    p = SimplePolynomial(Mod{13}.(0:4))
    @test p(0) == Mod{13}(0)
    @test 2p == p + p
    @test 3 * (p / 3) + 1 == Mod{13}(1) + p
end

@testset "Rational Basics" begin
    f = a / b
    g = b / a
    @test f * g == 1
    @test 2f == (a + a) / b
    @test (f - g)^2 == f^2 - 2f * g + g^2
    @test (f / g)^2 == (f^2) // (g^2)
end

@testset "Rational derivative" begin
    f = inv(1 + x)
    g = derivative(f)
    @test g == -1 // (1 + x)^2
end

@testset "Rational Mod" begin
    x = getx(Mod{13})
    p = Mod{13}(1) + x
    q = Mod{13}(2) + 3x
    f = p / q
    @test f(0) == Mod{13}(1 // 2)
end

@testset "Functionize" begin
    x = getx()
    p = 3 + 5x + 8x^2
    P = make_function(p)
    @test p(10) == P(10)

    f = p / (1 - x)
    F = make_function(f)
    @test F(10) == f(10)
    A = [2 3; 0 -1]
    p = -2 - x + x^2
    @test all(p(A) .== 0)
end

@testset "Rational Roots" begin
    x = getx()
    p = (x^2 + 1) * (2x - 1)^2 * (3x + 5)
    R = rational_roots(p)
    @test R == Multiset([1 // 2, -5 // 3, 1 // 2])
end

@testset "Numerical Roots" begin
    x = getx()
    p = (x^2 + 1) * (2x - 1)^2 * (3x + 5) * (x^2 + 2)
    R = roots(p)
    Z = p.(R)
    @test sum(abs(z) for z in Z) < 10^-10

    R = newton_roots(p)
    Z = p.(R)
    @test sum(abs(z) for z in Z) < 10^-50
end

@testset "Binomial coefficient" begin
    p = binomial(x, 4)
    @test p(10) == binomial(10, 4)
end

@testset "Interpolation" begin
    p = x^3 - 3 * x + 4
    vals = [p(k) for k = 0:5]
    q = interpolate(vals)
    @test p == q
end

nothing

"""
`small(x)` converts `x` to `Int`-level precision if there is
no loss. Applies to integer, rational, Gaussian integer,
Gaussian rational, and `SimplePolynomial`. It is a way of
undoing `big` (if possible).
"""
function small(x::T) where {T<:Integer}
    try
        x = Int(x)
    catch
    end
    return x
end

function small(x::Complex{T}) where {T<:Integer}
    try
        x = Complex{Int}(x)
    catch
    end
    return x
end

function small(x::Rational{T}) where {T<:Integer}
    try
        x = Rational{Int}(x)
    catch
    end
    return x
end


function small(x::Complex{Rational{T}}) where {T<:Integer}
    try
        x = Complex{Rational{Int}}(x)
    catch
    end
    return x
end

small(x::AbstractMod) = x

import Base: numerator, denominator, (==), zero, one, big

export SimpleRationalFunction


struct SimpleRationalFunction <: AbstractAlgebraicFunction
    num::SimplePolynomial
    den::SimplePolynomial
    function SimpleRationalFunction(top::SimplePolynomial, bot::SimplePolynomial)
        if bot == 0
            error("Denominator cannot be zero")
        end
        d = gcd(top, bot)
        t, r = divrem(top, d)
        b, r = divrem(bot, d)

        # make the denominator monic
        a = b.data[end]
        t = t / a
        b = b / a

        new(t, b)
    end
end

SimpleRationalFunction(f::SimplePolynomial) = SimpleRationalFunction(f, SimplePolynomial(1))
SimpleRationalFunction(f::SimpleRationalFunction) = SimpleRationalFunction(f.num, f.den)

SimpleRationalFunction(a::T) where {T<:CoefX} = SimpleRationalFunction(SimplePolynomial(a))
SimpleRationalFunction(a::T, f::SimplePolynomial) where {T<:CoefX} =
    SimpleRationalFunction(SimplePolynomial(a), f)
SimpleRationalFunction(f::SimplePolynomial, a::T) where {T<:CoefX} =
    SimpleRationalFunction(f, SimplePolynomial(a))
SimpleRationalFunction(a::T, b::S) where {T<:CoefX,S<:CoefX} =
    SimpleRationalFunction(a // b)
SimpleRationalFunction() = SimpleRationalFunction(0)


function make_function(f::SimpleRationalFunction)
    F(x) = (f.num.func(x)) / (f.den.func(x))
end




numerator(f::SimpleRationalFunction) = f.num
denominator(f::SimpleRationalFunction) = f.den

numerator(f::SimplePolynomial) = f
denominator(f::SimplePolynomial) = one(eltype(f))

(==)(f::SimpleRationalFunction, g::SimpleRationalFunction) =
    (f.num == g.num) && (f.den == g.den)
(==)(f::SimpleRationalFunction, p::SimplePolynomial) = f == SimpleRationalFunction(p)
(==)(p::SimplePolynomial, f::SimpleRationalFunction) = f == p
(==)(f::SimpleRationalFunction, a::T) where {T<:CoefX} = f == SimpleRationalFunction(a)
(==)(a::T, f::SimpleRationalFunction) where {T<:CoefX} = f == a

(f::SimpleRationalFunction)(x) = f.num(x) / f.den(x)

zero(::Type{SimpleRationalFunction}) = SimpleRationalFunction(0, 1)
zero(::SimpleRationalFunction) = SimpleRationalFunction(0, 1)
one(::Type{SimpleRationalFunction}) = SimpleRationalFunction(1, 1)
one(::SimpleRationalFunction) = SimpleRationalFunction(1, 1)

# big(f::SimpleRationalFunction) = SimpleRationalFunction(big(f.num),big(f.den))


function eltype(f::SimpleRationalFunction)
    T1 = eltype(numerator(f))
    T2 = eltype(denominator(f))
    return promote_type(T1,T2)
end


# include("arithmetic.jl")
# include("show.jl")

# addition
function (+)(f::SimpleRationalFunction, g::SimpleRationalFunction)
    top = f.num * g.den + f.den * g.num
    bot = f.den * g.den
    return SimpleRationalFunction(top, bot)
end

function (+)(f::SimpleRationalFunction, p::SimplePolynomial)
    return f + SimpleRationalFunction(p)
end
(+)(p::SimplePolynomial, f::SimpleRationalFunction) = f + p

(+)(f::SimpleRationalFunction, a::T) where {T<:CoefX} = f + SimpleRationalFunction(a)
(+)(a::T, f::SimpleRationalFunction) where {T<:CoefX} = f + a


# subtraction
(-)(f::SimpleRationalFunction) = SimpleRationalFunction(-f.num, f.den)

(-)(f::SimpleRationalFunction, g::SimpleRationalFunction) = f + (-g)

(-)(f::SimpleRationalFunction, p::SimplePolynomial) = f + (-p)
(-)(p::SimplePolynomial, f::SimpleRationalFunction) = p + (-f)

(-)(f::SimpleRationalFunction, a::T) where {T<:CoefX} = f + SimpleRationalFunction(-a)
(-)(a::T, f::SimpleRationalFunction) where {T<:CoefX} = SimpleRationalFunction(a) - f

# multiplication
(*)(f::SimpleRationalFunction, g::SimpleRationalFunction) =
    SimpleRationalFunction(f.num * g.num, f.den * g.den)

(*)(f::SimpleRationalFunction, p::SimplePolynomial) = f * SimpleRationalFunction(p)
(*)(p::SimplePolynomial, f::SimpleRationalFunction) = f * p

(*)(f::SimpleRationalFunction, a::T) where {T<:CoefX} = f * SimpleRationalFunction(a)
(*)(a::T, f::SimpleRationalFunction) where {T<:CoefX} = f * a

# division
inv(f::SimpleRationalFunction) = SimpleRationalFunction(f.den, f.num)

function inv(p::SimplePolynomial)
    T = eltype(p)
    SimpleRationalFunction(T(1), p)
end



SimpleThing = Union{SimplePolynomial,SimpleRationalFunction}

(/)(f::S, g::T) where {S<:SimpleThing,T<:SimpleThing} = f * inv(g)
(/)(f::SimpleRationalFunction, a::T) where {T<:CoefX} = f / SimplePolynomial(a)
(/)(a::T, f::S) where {T<:CoefX,S<:SimpleThing} = a * inv(f)



(//)(f::S, g::T) where {S<:SimpleThing,T<:SimpleThing} = f * inv(g)
(//)(f::SimpleRationalFunction, a::T) where {T<:CoefX} = f / SimplePolynomial(a)
(//)(a::T, f::S) where {T<:CoefX,S<:SimpleThing} = a * inv(f)


# exponentiation
function (^)(p::SimpleRationalFunction, k::S) where {S<:Integer}
    if k == 0
        return SimpleRationalFunction(1)
    end

    if k < 0
        return (inv(p))^(-k)
    end

    if k == 1
        return p
    end

    if k == 2
        return p * p
    end

    if k % 2 == 0  # even exponent
        j = k ÷ 2
        q = p^j
        return q * q
    end

    j = k ÷ 2
    q = p^j
    return q * q * p
end

# derivative
import SimplePolynomials: derivative
import Base: adjoint

function derivative(f::SimpleRationalFunction)
    p = numerator(f)
    q = denominator(f)
    return (p' * q - q' * p) / (q * q)
end
adjoint(f::SimpleRationalFunction) = derivative(f)
